/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the UsersList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UsersList{}

// UsersList struct for UsersList
type UsersList struct {
	Results []User `json:"results"`
	Total int32 `json:"total"`
}

// NewUsersList instantiates a new UsersList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUsersList(results []User, total int32) *UsersList {
	this := UsersList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewUsersListWithDefaults instantiates a new UsersList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUsersListWithDefaults() *UsersList {
	this := UsersList{}
	return &this
}

// GetResults returns the Results field value
func (o *UsersList) GetResults() []User {
	if o == nil {
		var ret []User
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *UsersList) GetResultsOk() ([]User, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *UsersList) SetResults(v []User) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *UsersList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *UsersList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *UsersList) SetTotal(v int32) {
	o.Total = v
}

func (o UsersList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UsersList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableUsersList struct {
	value *UsersList
	isSet bool
}

func (v NullableUsersList) Get() *UsersList {
	return v.value
}

func (v *NullableUsersList) Set(val *UsersList) {
	v.value = val
	v.isSet = true
}

func (v NullableUsersList) IsSet() bool {
	return v.isSet
}

func (v *NullableUsersList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUsersList(val *UsersList) *NullableUsersList {
	return &NullableUsersList{value: val, isSet: true}
}

func (v NullableUsersList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUsersList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


